VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "ItemDataList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Copyright (C) 1997-2010 Kei Sakamoto
' {t@Cyі{t@Cgč쐬vO
' fzz֎~܂B

'SACef[^Ǘ郊Xg̃NX

'ACef[^̃RNV
Private colItemDataList As New Collection


'NX̉
Private Sub Class_Terminate()
Dim i As Integer
    
    With colItemDataList
        For i = 1 To .Count
            .Remove 1
        Next
    End With
    Set colItemDataList = Nothing
End Sub

'ACef[^XgɃf[^ǉ
Public Function Add(new_name As String) As ItemData
Dim new_Item_data As New ItemData

    new_Item_data.Name = new_name
    colItemDataList.Add new_Item_data, new_name
    Set Add = new_Item_data
End Function

'ACef[^Xgɓo^Ăf[^̑
Public Function Count() As Integer
    Count = colItemDataList.Count
End Function

'ACef[^Xgw肵f[^폜
Public Sub Delete(Index As Variant)
    colItemDataList.Remove Index
End Sub

'ACef[^Xgw肵f[^o
Public Function Item(Index As Variant) As ItemData
    On Error GoTo ErrorHandler
    
    Set Item = colItemDataList.Item(Index)
    Exit Function
    
ErrorHandler:
    Set Item = Nothing
End Function

'ACef[^XgɎw肵f[^o^Ă邩H
Public Function IsDefined(Index As Variant) As Boolean
Dim dummy As ItemData

    On Error GoTo ErrorHandler
    Set dummy = colItemDataList.Item(Index)
    IsDefined = True
    Exit Function
    
ErrorHandler:
    IsDefined = False
End Function

'f[^t@C fname f[^[h
Public Sub Load(fname As String)
Dim FileNumber As Integer
Dim i As Integer, j As Integer, n As Long, line_num As Long
Dim line_buf As String, buf As String, buf2 As String
Dim ret As Integer
Dim nd As ItemData, wd As WeaponData, sd As AbilityData
Dim wname As String, sname As String
Dim data_name As String
Dim err_msg As String
Dim in_quote As Boolean
Dim comma_num As Integer

    On Error GoTo ErrorHandler
    
    FileNumber = FreeFile
    Open fname For Input Access Read As #FileNumber
    
    line_num = 0
    
    Do While True
        'sXLbv
        Do
            If EOF(FileNumber) Then
                Close #FileNumber
                Exit Sub
            End If
            GetLine FileNumber, line_buf, line_num
        Loop While Len(line_buf) = 0
        
        If InStr(line_buf, ",") > 0 Then
            err_msg = "̂̐ݒ肪Ă܂B"
            Error 0
        End If
        
        '
        data_name = line_buf
        
        If InStr(data_name, " ") > 0 Then
            err_msg = "̂ɔpXy[X͎gpo܂B"
            Error 0
        End If
        If InStr(data_name, "i") > 0 Or InStr(data_name, "j") > 0 Then
            err_msg = "̂ɑSpʂ͎gpo܂B"
            Error 0
        End If
        If InStr(data_name, """") > 0 Then
            err_msg = "̂""͎gpo܂B"
            Error 0
        End If
        
        If IsDefined(data_name) Then
            Delete data_name
        End If
        Set nd = Add(data_name)
        
        With nd
            '́Aǂ݉AACeNXA
            GetLine FileNumber, line_buf, line_num
            
            '`FbN̂߁AR}̐𐔂Ă
            comma_num = 0
            For i = 1 To Len(line_buf)
                If Mid$(line_buf, i, 1) = "," Then
                    comma_num = comma_num + 1
                End If
            Next
            
            If comma_num < 2 Then
                err_msg = "ݒɔ܂B"
                Error 0
            ElseIf comma_num > 3 Then
                err_msg = "]ȁu,v܂B"
                Error 0
            End If
            
            '
            If Len(line_buf) = 0 Then
                err_msg = "̂̐ݒ肪Ă܂B"
                Error 0
            End If
            ret = InStr(line_buf, ",")
            buf2 = Trim$(Left$(line_buf, ret - 1))
            buf = Mid$(line_buf, ret + 1)
            .Nickname = buf2
            
            'ǂ݉
            If comma_num = 3 Then
                ret = InStr(buf, ",")
                buf2 = Trim$(Left$(buf, ret - 1))
                buf = Mid$(buf, ret + 1)
                .KanaName = buf2
            Else
                .KanaName = StrToHiragana(.Nickname)
            End If
            
            'ACeNX
            ret = InStr(buf, ",")
            buf2 = Trim$(Left$(buf, ret - 1))
            buf = Mid$(buf, ret + 1)
            .Class = buf2
            
            '
            buf2 = Trim$(buf)
            If Len(buf2) = 0 Then
                err_msg = "̐ݒ肪Ă܂B"
                Error 0
            End If
            .Part = buf2
            
            '\̓f[^
            GetLine FileNumber, line_buf, line_num
            If line_buf = "\͂Ȃ" Then
                GetLine FileNumber, line_buf, line_num
            ElseIf line_buf = "\" Then
                'V`ɂ\͕\L
                GetLine FileNumber, line_buf, line_num
                
                buf = line_buf
                i = 0
                Do While True
                    i = i + 1
                    
                    ret = 0
                    in_quote = False
                    For j = 1 To Len(buf)
                        Select Case Mid$(buf, j, 1)
                            Case ","
                                If Not in_quote Then
                                    ret = j
                                    Exit For
                                End If
                            Case """"
                                in_quote = Not in_quote
                        End Select
                    Next
                    
                    If ret > 0 Then
                        buf2 = Trim$(Left$(buf, ret - 1))
                        
                        If i = 1 Then
                            If IsNumeric(buf2) Then
                                Exit Do
                            End If
                        End If
                        
                        buf = Trim$(Mid$(buf, ret + 1))
                    Else
                        buf2 = buf
                        buf = ""
                    End If
                    
                    If buf2 <> "" Then
                        .AddFeature buf2
                    Else
                        DataErrorMessage "s" & Format$(i) & _
                            "Ԗڂ̓\͂̐ݒ肪ԈĂ܂B", _
                            fname, line_num, line_buf, data_name
                    End If
                    
                    If buf = "" Then
                        GetLine FileNumber, line_buf, line_num
                        buf = line_buf
                        i = 0
                    End If
                Loop
            ElseIf InStr(line_buf, "\,") = 1 Then
                '`ɂ\͕\L
                buf = Mid$(line_buf, 6)
                
                ret = 0
                in_quote = False
                For j = 1 To Len(buf)
                    Select Case Mid$(buf, j, 1)
                        Case ","
                            If Not in_quote Then
                                ret = j
                                Exit For
                            End If
                        Case """"
                            in_quote = Not in_quote
                    End Select
                Next
                
                i = 0
                Do While ret > 0
                    i = i + 1
                    buf2 = Trim$(Left$(buf, ret - 1))
                    buf = Mid$(buf, ret + 1)
                    ret = InStr(buf, ",")
                    If buf2 <> "" Then
                        .AddFeature buf2
                    Else
                        DataErrorMessage Format$(i) & "Ԗڂ̓\͂̐ݒ肪ԈĂ܂B", _
                            fname, line_num, line_buf, data_name
                    End If
                Loop
                
                i = i + 1
                buf2 = Trim$(buf)
                If buf2 <> "" Then
                    .AddFeature buf2
                Else
                    DataErrorMessage Format$(i) & "Ԗڂ̓\͂̐ݒ肪ԈĂ܂B", _
                        fname, line_num, line_buf, data_name
                End If
                
                GetLine FileNumber, line_buf, line_num
            Else
                err_msg = "\͂̐ݒ肪Ă܂B"
                Error 0
            End If
            
            'őgoCl, ődmCl, bCl, ^Cl, ړ͏Cl
            
            'őgoCl
            ret = InStr(line_buf, ",")
            If ret = 0 Then
                err_msg = "ődmCl̐ݒ肪Ă܂B"
                Error 0
            End If
            buf2 = Trim$(Left$(line_buf, ret - 1))
            buf = Mid$(line_buf, ret + 1)
            If IsNumeric(buf2) Then
                .HP = CLng(buf2)
            Else
                DataErrorMessage "őgoCl̐ݒ肪ԈĂ܂B", _
                    fname, line_num, line_buf, data_name
            End If
            
            'ődmCl
            ret = InStr(buf, ",")
            If ret = 0 Then
                err_msg = "bCl̐ݒ肪Ă܂B"
                Error 0
            End If
            buf2 = Trim$(Left$(buf, ret - 1))
            buf = Mid$(buf, ret + 1)
            If IsNumeric(buf2) Then
                .EN = CLng(buf2)
            Else
                DataErrorMessage "ődmCl̐ݒ肪ԈĂ܂B", _
                    fname, line_num, line_buf, data_name
            End If
            
            'bCl
            ret = InStr(buf, ",")
            If ret = 0 Then
                err_msg = "^Cl̐ݒ肪Ă܂B"
                Error 0
            End If
            buf2 = Trim$(Left$(buf, ret - 1))
            buf = Mid$(buf, ret + 1)
            If IsNumeric(buf2) Then
                .Armor = CLng(buf2)
            Else
                DataErrorMessage "bCl̐ݒ肪ԈĂ܂B", _
                    fname, line_num, line_buf, data_name
            End If
            
            '^Cl
            ret = InStr(buf, ",")
            If ret = 0 Then
                err_msg = "ړ͏Cl̐ݒ肪Ă܂B"
                Error 0
            End If
            buf2 = Trim$(Left$(buf, ret - 1))
            buf = Mid$(buf, ret + 1)
            If IsNumeric(buf2) Then
                .Mobility = CLng(buf2)
            Else
                DataErrorMessage "^Cl̐ݒ肪ԈĂ܂B", _
                    fname, line_num, line_buf, data_name
            End If
            
            'ړ͏Cl
            buf2 = Trim$(buf)
            If Len(buf2) = 0 Then
                err_msg = "ړ͏Cl̐ݒ肪Ă܂B"
                Error 0
            End If
            If IsNumeric(buf2) Then
                .Speed = CLng(buf2)
            Else
                DataErrorMessage "ړ͏Cl̐ݒ肪ԈĂ܂B", _
                    fname, line_num, line_buf, data_name
            End If
            
            If EOF(FileNumber) Then
                Close #FileNumber
                Exit Sub
            End If
            
            'f[^
            GetLine FileNumber, line_buf, line_num
            Do While Len(line_buf) > 0 And Left$(line_buf, 1) <> "*" And line_buf <> "==="
                '햼
                ret = InStr(line_buf, ",")
                If ret = 0 Then
                    err_msg = "f[^̏Iɂ͋suĂB"
                    Error 0
                End If
                wname = Trim$(Left$(line_buf, ret - 1))
                buf = Mid$(line_buf, ret + 1)
                
                If wname = "" Then
                    err_msg = "햼̐ݒ肪ԈĂ܂B"
                    Error 0
                End If
                
                'o^
                Set wd = .AddWeapon(wname)
                
                'U
                ret = InStr(buf, ",")
                If ret = 0 Then
                    err_msg = wname & "̍ŏ˒Ă܂B"
                    Error 0
                End If
                buf2 = Trim$(Left$(buf, ret - 1))
                buf = Mid$(buf, ret + 1)
                If IsNumeric(buf2) Then
                    wd.Power = MinLng(CLng(buf2), 99999)
                ElseIf buf = "-" Then
                    wd.Power = 0
                Else
                    DataErrorMessage wname & "̍U͂̐ݒ肪ԈĂ܂B", _
                        fname, line_num, line_buf, data_name
                    If LLength(buf2) > 1 Then
                        buf = LIndex(buf2, 2) & "," & buf
                        wd.Power = StrToLng(LIndex(buf2, 1))
                    End If
                End If
                
                'ŏ˒
                ret = InStr(buf, ",")
                If ret = 0 Then
                    err_msg = wname & "̍ő˒̐ݒ肪Ă܂B"
                    Error 0
                End If
                buf2 = Trim$(Left$(buf, ret - 1))
                buf = Mid$(buf, ret + 1)
                If IsNumeric(buf2) Then
                    wd.MinRange = MinLng(CLng(buf2), 99)
                Else
                    DataErrorMessage wname & "̍ŏ˒̐ݒ肪ԈĂ܂B", _
                        fname, line_num, line_buf, data_name
                    wd.MinRange = 1
                    If LLength(buf2) > 1 Then
                        buf = LIndex(buf2, 2) & "," & buf
                        wd.MinRange = StrToLng(LIndex(buf2, 1))
                    End If
                End If
                
                'ő˒
                ret = InStr(buf, ",")
                If ret = 0 Then
                    err_msg = wname & "̖̐ݒ肪Ă܂B"
                    Error 0
                End If
                buf2 = Trim$(Left$(buf, ret - 1))
                buf = Mid$(buf, ret + 1)
                If IsNumeric(buf2) Then
                    wd.MaxRange = MinLng(CLng(buf2), 99)
                Else
                    DataErrorMessage wname & "̍ő˒̐ݒ肪ԈĂ܂B", _
                        fname, line_num, line_buf, data_name
                    wd.MaxRange = 1
                    If LLength(buf2) > 1 Then
                        buf = LIndex(buf2, 2) & "," & buf
                        wd.MaxRange = StrToLng(LIndex(buf2, 1))
                    End If
                End If
                
                '
                ret = InStr(buf, ",")
                If ret = 0 Then
                    err_msg = wname & "̒e̐ݒ肪Ă܂B"
                    Error 0
                End If
                buf2 = Trim$(Left$(buf, ret - 1))
                buf = Mid$(buf, ret + 1)
                If IsNumeric(buf2) Then
                    n = CLng(buf2)
                    If n > 999 Then
                        n = 999
                    ElseIf n < -999 Then
                        n = -999
                    End If
                    wd.Precision = n
                Else
                    DataErrorMessage wname & "̖̐ݒ肪ԈĂ܂B", _
                        fname, line_num, line_buf, data_name
                    If LLength(buf2) > 1 Then
                        buf = LIndex(buf2, 2) & "," & buf
                        wd.Precision = StrToLng(LIndex(buf2, 1))
                    End If
                End If
                
                'e
                ret = InStr(buf, ",")
                If ret = 0 Then
                    err_msg = wname & "̏dm̐ݒ肪Ă܂B"
                    Error 0
                End If
                buf2 = Trim$(Left$(buf, ret - 1))
                buf = Mid$(buf, ret + 1)
                If buf2 <> "-" Then
                    If IsNumeric(buf2) Then
                        wd.Bullet = MinLng(CLng(buf2), 99)
                    Else
                        DataErrorMessage wname & "̒e̐ݒ肪ԈĂ܂B", _
                            fname, line_num, line_buf, data_name
                        If LLength(buf2) > 1 Then
                            buf = LIndex(buf2, 2) & "," & buf
                            wd.Bullet = StrToLng(LIndex(buf2, 1))
                        End If
                    End If
                End If
                
                'dm
                ret = InStr(buf, ",")
                If ret = 0 Then
                    err_msg = wname & "̕KvC͂Ă܂B"
                    Error 0
                End If
                buf2 = Trim$(Left$(buf, ret - 1))
                buf = Mid$(buf, ret + 1)
                If buf2 <> "-" Then
                    If IsNumeric(buf2) Then
                        wd.ENConsumption = MinLng(CLng(buf2), 999)
                    Else
                        DataErrorMessage wname & "̏dm̐ݒ肪ԈĂ܂B", _
                            fname, line_num, line_buf, data_name
                        If LLength(buf2) > 1 Then
                            buf = LIndex(buf2, 2) & "," & buf
                            wd.ENConsumption = StrToLng(LIndex(buf2, 1))
                        End If
                    End If
                End If
                
                'KvC
                ret = InStr(buf, ",")
                If ret = 0 Then
                    err_msg = wname & "̒n`KĂ܂B"
                    Error 0
                End If
                buf2 = Trim$(Left$(buf, ret - 1))
                buf = Mid$(buf, ret + 1)
                If buf2 <> "-" Then
                    If IsNumeric(buf2) Then
                        n = CLng(buf2)
                        If n > 1000 Then
                            n = 1000
                        ElseIf n < 0 Then
                            n = 0
                        End If
                        wd.NecessaryMorale = n
                    Else
                        DataErrorMessage wname & "̕KvC͂̐ݒ肪ԈĂ܂B", _
                            fname, line_num, line_buf, data_name
                        If LLength(buf2) > 1 Then
                            buf = LIndex(buf2, 2) & "," & buf
                            wd.NecessaryMorale = StrToLng(LIndex(buf2, 1))
                        End If
                    End If
                End If
                
                'n`K
                ret = InStr(buf, ",")
                If ret = 0 Then
                    err_msg = wname & "̃NeBJĂ܂B"
                    Error 0
                End If
                buf2 = Trim$(Left$(buf, ret - 1))
                buf = Mid$(buf, ret + 1)
                If Len(buf2) = 4 Then
                    wd.Adaption = buf2
                Else
                    DataErrorMessage wname & "̒n`K̐ݒ肪ԈĂ܂B", _
                        fname, line_num, line_buf, data_name
                    wd.Adaption = "----"
                    If LLength(buf2) > 1 Then
                        buf = LIndex(buf2, 2) & "," & buf
                        wd.Adaption = LIndex(buf2, 1)
                    End If
                End If
                
                'NeBJ
                ret = InStr(buf, ",")
                If ret = 0 Then
                    err_msg = wname & "̕푮Ă܂B"
                    Error 0
                End If
                buf2 = Trim$(Left$(buf, ret - 1))
                buf = Mid$(buf, ret + 1)
                If IsNumeric(buf2) Then
                    n = CLng(buf2)
                    If n > 999 Then
                        n = 999
                    ElseIf n < -999 Then
                        n = -999
                    End If
                    wd.Critical = n
                Else
                    DataErrorMessage wname & "̃NeBJ̐ݒ肪ԈĂ܂B", _
                        fname, line_num, line_buf, data_name
                    If LLength(buf2) > 1 Then
                        buf = LIndex(buf2, 2) & "," & buf
                        wd.Critical = StrToLng(LIndex(buf2, 1))
                    End If
                End If
                
                '푮
                buf = Trim$(buf)
                If Len(buf) = 0 Then
                    DataErrorMessage wname & "̕푮̐ݒ肪ԈĂ܂B", _
                        fname, line_num, line_buf, data_name
                End If
                If Right$(buf, 1) = ")" Then
                    'KvZ\
                    ret = InStr(buf, "> ")
                    If ret > 0 Then
                        If ret > 0 Then
                            wd.NecessarySkill = Mid$(buf, ret + 2)
                            buf = Trim$(Left$(buf, ret + 1))
                            ret = InStr(wd.NecessarySkill, "(")
                            wd.NecessarySkill = _
                                Mid$(wd.NecessarySkill, ret + 1, Len(wd.NecessarySkill) - ret - 1)
                        End If
                    Else
                        ret = InStr(buf, "(")
                        If ret > 0 Then
                            wd.NecessarySkill = Trim$(Mid$(buf, ret + 1, Len(buf) - ret - 1))
                            buf = Trim$(Left$(buf, ret - 1))
                        End If
                    End If
                End If
                If Right$(buf, 1) = ">" Then
                    'Kv
                    ret = InStr(buf, "<")
                    If ret > 0 Then
                        wd.NecessaryCondition = Trim$(Mid$(buf, ret + 1, Len(buf) - ret - 1))
                        buf = Trim$(Left$(buf, ret - 1))
                    End If
                End If
                wd.Class = buf
                If wd.Class = "-" Then
                    wd.Class = ""
                End If
                If InStr(wd.Class, "Lv") > 0 Then
                    DataErrorMessage wname & "̑̃xw肪ԈĂ܂B", _
                        fname, line_num, line_buf, data_name
                End If
                
                If EOF(FileNumber) Then
                    Close #FileNumber
                    Exit Sub
                End If
                
                GetLine FileNumber, line_buf, line_num
            Loop
            
            If line_buf <> "===" Then
                GoTo SkipRest
            End If
            
            'AreBf[^
            GetLine FileNumber, line_buf, line_num
            Do While Len(line_buf) > 0 And Left$(line_buf, 1) <> "*"
                'AreB
                ret = InStr(line_buf, ",")
                If ret = 0 Then
                    err_msg = "AreBf[^̏Iɂ͋suĂB"
                    Error 0
                End If
                sname = Trim$(Left$(line_buf, ret - 1))
                buf = Mid$(line_buf, ret + 1)
                
                If sname = "" Then
                    err_msg = "AreB̐ݒ肪ԈĂ܂B"
                    Error 0
                End If
                
                'AreBo^
                Set sd = .AddAbility(sname)
                
                '
                ret = InStr(buf, ",")
                If ret = 0 Then
                    err_msg = sname & "̎˒̐ݒ肪Ă܂B"
                    Error 0
                End If
                buf2 = Trim$(Left$(buf, ret - 1))
                buf = Mid$(buf, ret + 1)
                sd.SetEffect buf2
                
                '˒
                sd.MinRange = 0
                ret = InStr(buf, ",")
                If ret = 0 Then
                    err_msg = sname & "̉񐔂̐ݒ肪Ă܂B"
                    Error 0
                End If
                buf2 = Trim$(Left$(buf, ret - 1))
                buf = Mid$(buf, ret + 1)
                If IsNumeric(buf2) Then
                    sd.MaxRange = MinLng(CLng(buf2), 99)
                ElseIf buf2 = "-" Then
                    sd.MaxRange = 0
                Else
                    DataErrorMessage sname & "̎˒̐ݒ肪ԈĂ܂B", _
                        fname, line_num, line_buf, data_name
                    If LLength(buf2) > 1 Then
                        buf = LIndex(buf2, 2) & "," & buf
                        sd.MaxRange = StrToLng(LIndex(buf2, 1))
                    End If
                End If
                
                '
                ret = InStr(buf, ",")
                If ret = 0 Then
                    err_msg = sname & "̏dm̐ݒ肪Ă܂B"
                    Error 0
                End If
                buf2 = Trim$(Left$(buf, ret - 1))
                buf = Mid$(buf, ret + 1)
                If buf2 <> "-" Then
                    If IsNumeric(buf2) Then
                        sd.Stock = MinLng(CLng(buf2), 99)
                    Else
                        DataErrorMessage sname & "̉񐔂̐ݒ肪ԈĂ܂B", _
                            fname, line_num, line_buf, data_name
                        If LLength(buf2) > 1 Then
                            buf = LIndex(buf2, 2) & "," & buf
                            sd.Stock = StrToLng(LIndex(buf2, 1))
                        End If
                    End If
                End If
                
                'dm
                ret = InStr(buf, ",")
                If ret = 0 Then
                    err_msg = sname & "̕KvC͂̐ݒ肪Ă܂B"
                    Error 0
                End If
                buf2 = Trim$(Left$(buf, ret - 1))
                buf = Mid$(buf, ret + 1)
                If buf2 <> "-" Then
                    If IsNumeric(buf2) Then
                        sd.ENConsumption = MinLng(CLng(buf2), 999)
                    Else
                        DataErrorMessage sname & "̏dm̐ݒ肪ԈĂ܂B", _
                            fname, line_num, line_buf, data_name
                        If LLength(buf2) > 1 Then
                            buf = LIndex(buf2, 2) & "," & buf
                            sd.ENConsumption = StrToLng(LIndex(buf2, 1))
                        End If
                    End If
                End If
                
                'KvC
                ret = InStr(buf, ",")
                If ret = 0 Then
                    err_msg = sname & "̃AreB̐ݒ肪Ă܂B"
                    Error 0
                End If
                buf2 = Trim$(Left$(buf, ret - 1))
                buf = Mid$(buf, ret + 1)
                If buf2 <> "-" Then
                    If IsNumeric(buf2) Then
                        n = CLng(buf2)
                        If n > 1000 Then
                            n = 1000
                        ElseIf n < 0 Then
                            n = 0
                        End If
                        sd.NecessaryMorale = n
                    Else
                        DataErrorMessage sname & "̕KvC͂̐ݒ肪ԈĂ܂B", _
                            fname, line_num, line_buf, data_name
                        If LLength(buf2) > 1 Then
                            buf = LIndex(buf2, 2) & "," & buf
                            sd.NecessaryMorale = StrToLng(LIndex(buf2, 1))
                        End If
                    End If
                End If
                
                'AreB
                buf = Trim$(buf)
                If Len(buf) = 0 Then
                    DataErrorMessage sname & "̃AreB̐ݒ肪ԈĂ܂B", _
                        fname, line_num, line_buf, data_name
                End If
                If Right$(buf, 1) = ")" Then
                    'KvZ\
                    ret = InStr(buf, "> ")
                    If ret > 0 Then
                        If ret > 0 Then
                            sd.NecessarySkill = Mid$(buf, ret + 2)
                            buf = Trim$(Left$(buf, ret + 1))
                            ret = InStr(sd.NecessarySkill, "(")
                            sd.NecessarySkill = _
                                Mid$(sd.NecessarySkill, ret + 1, Len(sd.NecessarySkill) - ret - 1)
                        End If
                    Else
                        ret = InStr(buf, "(")
                        If ret > 0 Then
                            sd.NecessarySkill = Trim$(Mid$(buf, ret + 1, Len(buf) - ret - 1))
                            buf = Trim$(Left$(buf, ret - 1))
                        End If
                    End If
                End If
                If Right$(buf, 1) = ">" Then
                    'Kv
                    ret = InStr(buf, "<")
                    If ret > 0 Then
                        sd.NecessaryCondition = Trim$(Mid$(buf, ret + 1, Len(buf) - ret - 1))
                        buf = Trim$(Left$(buf, ret - 1))
                    End If
                End If
                sd.Class = buf
                If sd.Class = "-" Then
                    sd.Class = ""
                End If
                If InStr(sd.Class, "Lv") > 0 Then
                    DataErrorMessage sname & "̑̃xw肪ԈĂ܂B", _
                        fname, line_num, line_buf, data_name
                End If
                
                If EOF(FileNumber) Then
                    Close #FileNumber
                    Exit Sub
                End If
                
                GetLine FileNumber, line_buf, line_num
            Loop
            
SkipRest:
            
            '
            Do While Left$(line_buf, 1) = "*"
                If Len(.Comment) > 0 Then
                    .Comment = .Comment & vbCr & vbLf
                End If
                .Comment = .Comment & Mid$(line_buf, 2)
                If EOF(FileNumber) Then
                    Exit Do
                End If
                GetLine FileNumber, line_buf, line_num
            Loop
        End With
    Loop
    
ErrorHandler:
    'G[
    If line_num = 0 Then
        ErrorMessage fname & "J܂B"
    Else
        Close #FileNumber
        DataErrorMessage err_msg, fname, line_num, line_buf, data_name
    End If
    TerminateSRC
End Sub

